#------------------------------------------------------#
# MISCELLANEOUS MCMC FUNCTIONS USED IN MULTIPLE MODELS #
#------------------------------------------------------#

#-----------------------
#MH DECIDE FUNCTION:
decide<-function(log.MH) {
  if(is.na(log.MH)){
    print(log.MH)
    log.MH=-Inf
  }
	if(runif(1,min=0,max=1) < exp(log.MH))	return(TRUE)
	else return(FALSE)
}


#-----------------------
acceptance.rate<-function(mcmc.chain) sum(mcmc.chain[2:length(mcmc.chain)]!=mcmc.chain[1:(length(mcmc.chain)-1)])/length(mcmc.chain)


#---------------------------------
na.cnt<-function(data.temp) sum(!is.na(data.temp))

#------------------------------
gamma.beta.bivnorm <- function(cov.mat,current.log.gamma,current.log.beta,sim.area,current.z.1.nminus1,current.sim.alpha.distance,current.p.extinct,current.z.2.n,log.denominator.2.n,one.m,zero.m) {
			proposed.log.gamma.beta=rmvnorm(n=1,mean=c(current.log.gamma,current.log.beta),sigma=cov.mat)
			proposed.log.gamma=proposed.log.gamma.beta[1]
			proposed.log.beta=proposed.log.gamma.beta[2]
			proposed.area.j.beta=sim.area^exp(proposed.log.beta)
			proposed.area.occ.1.nminus1=current.z.1.nminus1*proposed.area.j.beta
			proposed.s.i.sq.1.nminus1=(current.sim.alpha.distance%*%proposed.area.occ.1.nminus1)^2
			proposed.p.colon.2.n=proposed.s.i.sq.1.nminus1/(proposed.s.i.sq.1.nminus1+exp(2*proposed.log.gamma))
			proposed.p.extinct.re.2.n=current.p.extinct*(1-proposed.p.colon.2.n) 
			proposed.prob.mat.2.n=current.z.1.nminus1*(1-proposed.p.extinct.re.2.n)+(1-current.z.1.nminus1)*proposed.p.colon.2.n
                        if (sum(is.na(proposed.prob.mat.2.n))>0) {
                          print("NAs in Prob")
                          proposed.prob.mat.2.n[proposed.s.i.sq.1.nminus1==Inf]=one.m[proposed.s.i.sq.1.nminus1==Inf]
                        }
                        if(sum(proposed.prob.mat.2.n<=0)>0) {
                          print("Zeros in Prob")
                          proposed.prob.mat.2.n[proposed.prob.mat.2.n<=0]=zero.m[proposed.prob.mat.2.n<=0]
                        }
			if(sum(proposed.prob.mat.2.n>=1)>0) {
                          print("Ones in Prob")
                          proposed.prob.mat.2.n[proposed.prob.mat.2.n>=1]=one.m[proposed.prob.mat.2.n>=1]
                        }
			log.numerator.2.n=sum(current.z.2.n*log(proposed.prob.mat.2.n)+(1-current.z.2.n)*log(1-proposed.prob.mat.2.n))

			log.MH=log.numerator.2.n-log.denominator.2.n
			accept=decide(log.MH)
			if(proposed.log.gamma<(-20) | proposed.log.beta<(-10)) accept=0
                        if(proposed.log.gamma>20 | proposed.log.beta>10) accept=0
			if(accept) {
                          return(list(
                                accept=accept,
				current.log.beta=proposed.log.beta,
				current.log.gamma=proposed.log.gamma,
				current.area.j.beta=proposed.area.j.beta,
				current.area.occ.1.nminus1=proposed.area.occ.1.nminus1,
                                current.s.i.sq.1.nminus1=proposed.s.i.sq.1.nminus1,
                                current.p.colon.2.n=proposed.p.colon.2.n,
				current.prob.mat.2.n=proposed.prob.mat.2.n,
                           	log.denominator.2.n=log.numerator.2.n))
				}
                        else return(list(accept=accept))
			}

