
#-----IFM ASSUMING NO MISSING DATA AND PERFECT DETECTION

gamma.beta.bivnorm.no.missing <- function(current.log.gamma,current.log.beta,cov.mat,z.index.list,sim.area,proposed.area.occ.list,proposed.s.i.sq.list,z.data.list,current.sim.alpha.distance.list,current.p.extinct.stack,z.data.1.nminus1.stack,one.stack,zero.stack,z.data.2.n.stack,log.denominator.2.n){
  proposed.log.gamma.beta=rmvnorm(n=1,mean=c(current.log.gamma,current.log.beta),sigma=cov.mat)
		proposed.log.gamma=proposed.log.gamma.beta[1]
		proposed.log.beta=proposed.log.gamma.beta[2]
                proposed.area.j.beta=sim.area^exp(proposed.log.beta)
                proposed.p.colon.stack=NULL
                for(i in 1:(nyear-1)) {
                  proposed.area.occ.list[[i]]=z.data.list[[i]][,1]*proposed.area.j.beta[z.index.list[[i]]]
                  proposed.s.i.sq.list[[i]]=(current.sim.alpha.distance.list[[i]]%*%proposed.area.occ.list[[i]])^2
                  proposed.p.colon.stack=c(proposed.p.colon.stack,(proposed.s.i.sq.list[[i]]/(proposed.s.i.sq.list[[i]]+exp(2*proposed.log.gamma))))
                }

                proposed.p.extinct.re.stack=current.p.extinct.stack*(1-proposed.p.colon.stack)
                proposed.prob.stack=z.data.1.nminus1.stack*(1-proposed.p.extinct.re.stack)+(1-z.data.1.nminus1.stack)*proposed.p.colon.stack
                if (sum(is.na(proposed.prob.stack))>0) 	proposed.prob.stack[proposed.s.i.sq.list==Inf]=one.stack[proposed.s.i.sq.list==Inf]
                if(sum(proposed.prob.stack>=1)>0) proposed.prob.stack[proposed.prob.stack>=1]=one.stack[proposed.prob.stack>=1]
                if(sum(proposed.prob.stack<=0)>0) proposed.prob.stack[proposed.prob.stack<=0]=zero.stack[proposed.prob.stack<=0]
                  
                log.numerator.2.n=sum(z.data.2.n.stack*log(proposed.prob.stack)+(1-z.data.2.n.stack)*log(1-proposed.prob.stack))
                log.MH=log.numerator.2.n-log.denominator.2.n
		accept=decide(log.MH)
		if(proposed.log.gamma<(-20) | proposed.log.beta<(-10)) accept=0
  if(proposed.log.gamma>20 | proposed.log.beta>10) accept=0
  if(accept) {
		return(list(
                accept=accept,
		current.log.gamma=proposed.log.gamma,
                current.log.beta=proposed.log.beta,
		current.area.occ.list=proposed.area.occ.list,
                current.s.i.sq.list=proposed.s.i.sq.list,
                current.p.colon.stack=proposed.p.colon.stack,
                log.denominator.2.n=log.numerator.2.n))
		}
  else return(list(accept=accept))
              }



#-------------------------------------
ifm.no.missing.MCMC <- function(niter=1000,init,z.data, sim.distance, sim.area, sd.prop.mupsi1=0.1, sd.prop.mu=0.2, sd.prop.chi=0.2,sd.prop.gamma=0.2, sd.prop.beta=0.2, sd.prop.alpha=0.2,gamma.beta.bivnorm.high=FALSE,gamma.beta.bivnorm.low=FALSE,cov.prop.gamma.beta.high=matrix(c(2.22,0.58,0.58,0.17),nrow=2),cov.prop.gamma.beta.low=matrix(c(0.05,0.035,0.035,0.15),nrow=2),seed=round(runif(1,0,10000)),gamma.twice=FALSE, beta.twice=FALSE,alpha.twice=FALSE,nthin=1,print.by=100) {
	
	iter.chain=seq(1,niter,by=nthin)
	iter.chain=sort(rep(iter.chain,nthin))
        iter.print=seq(1,niter,by=print.by)
        iter.print=sort(rep(iter.print,print.by))
	set.seed(seed)
	
	log.mu.chain=NULL
	log.chi.chain=NULL
	log.gamma.chain=NULL
	log.beta.chain=NULL
	log.alpha.chain=NULL

	current.log.mu=init$log.mu
	current.log.chi=init$log.chi
	current.log.gamma=init$log.gamma
	current.log.beta=init$log.beta
	current.log.alpha=init$log.alpha

        z.index.list=new.env()
        z.data.list=new.env()

        nyear=ncol(z.data)
        for(i in (nyear-1):1){
          temp1=c(1:nsite)[!is.na(z.data[,i]) & !is.na(z.data[,(i+1)])]
          assign(paste("z.",i,".",(i+1),".index",sep=""),temp1,z.index.list)
          temp2=z.data[temp1,c(i,(i+1))]
          assign(paste("z.",i,".",(i+1),sep=""),temp2,z.data.list)
        }
        z.index.list=as.list(z.index.list)
        z.data.list=as.list(z.data.list)
       
        if(names(z.index.list)[1]!="z.1.2.index") stop("Z INDEX MIS-SORTED")
  
        current.sim.alpha.distance.list=list(rep(NA,nyear))
        current.area.j.beta=sim.area^exp(current.log.beta)
        current.area.occ.list=list(rep(NA,nyear))
        current.s.i.sq.list=list(rep(NA,nyear))
        
        z.data.1.nminus1.stack=NULL
        z.data.2.n.stack=NULL
        current.p.colon.stack=NULL
        current.p.extinct.stack=NULL
        
        current.sim.area.chi=sim.area^exp(current.log.chi)
	current.p.extinct=exp(current.log.mu)/current.sim.area.chi
	current.p.extinct[current.p.extinct>1]=1
        current.sim.alpha.distance=exp(-exp(current.log.alpha)*sim.distance)
        diag(current.sim.alpha.distance)=0
        
        for(i in 1:(nyear-1)) {
          z.data.1.nminus1.stack=c(z.data.1.nminus1.stack,z.data.list[[i]][,1])
          z.data.2.n.stack=c(z.data.2.n.stack,z.data.list[[i]][,2])
          current.sim.alpha.distance.list[[i]]=current.sim.alpha.distance[z.index.list[[i]],z.index.list[[i]]]
          current.area.occ.list[[i]]=z.data.list[[i]][,1]*current.area.j.beta[z.index.list[[i]]]
          current.s.i.sq.list[[i]]=(current.sim.alpha.distance.list[[i]]%*%current.area.occ.list[[i]])^2
          current.p.colon.stack=c(current.p.colon.stack,(current.s.i.sq.list[[i]]/(current.s.i.sq.list[[i]]+exp(2*current.log.gamma))))
          current.p.extinct.stack=c(current.p.extinct.stack,current.p.extinct[z.index.list[[i]]])
        }

        current.p.extinct.re.stack=current.p.extinct.stack*(1-current.p.colon.stack)
        current.prob.stack=z.data.1.nminus1.stack*(1-current.p.extinct.re.stack)+(1-z.data.1.nminus1.stack)*current.p.colon.stack
    	log.denominator.2.n=sum(z.data.2.n.stack*log(current.prob.stack)+(1-z.data.2.n.stack)*log(1-current.prob.stack))

        proposed.sim.alpha.distance.list=current.sim.alpha.distance.list
        proposed.area.occ.list=current.area.occ.list
        proposed.s.i.sq.list=current.s.i.sq.list
    
	zero.stack=rep(0.00001,length(current.prob.stack))
	one.stack=rep(0.99999,length(current.prob.stack))


        #-----------------------
        # ITERATIONS LOOP
        #-----------------------
	for (n in 1:niter) {
		#-----------------
		#-----------MU
                #-----------------
          if(sd.prop.mu>0) {
		proposed.log.mu=rnorm(1,current.log.mu,sd=sd.prop.mu) 
		if(proposed.log.mu<(-10)) {
			proposed.log.mu=-20-proposed.log.mu
			}
		if(proposed.log.mu>10) {
			proposed.log.mu=20-proposed.log.mu
			}
		proposed.p.extinct=exp(proposed.log.mu)/current.sim.area.chi
		proposed.p.extinct[proposed.p.extinct>1]=1
                proposed.p.extinct.stack=NULL
                for(i in 1:(nyear-1)) {
                  proposed.p.extinct.stack=c(proposed.p.extinct.stack,proposed.p.extinct[z.index.list[[i]]])
                }

        proposed.p.extinct.re.stack=proposed.p.extinct.stack*(1-current.p.colon.stack)
        proposed.prob.stack=z.data.1.nminus1.stack*(1-proposed.p.extinct.re.stack)+(1-z.data.1.nminus1.stack)*current.p.colon.stack
    	log.numerator.2.n=sum(z.data.2.n.stack*log(proposed.prob.stack)+(1-z.data.2.n.stack)*log(1-proposed.prob.stack))
        log.MH=log.numerator.2.n-log.denominator.2.n
	accept=decide(log.MH)
		if (accept) {
			current.log.mu=proposed.log.mu
			current.p.extinct.stack=proposed.p.extinct.stack
                        log.denominator.2.n=log.numerator.2.n
			}
              }
		#-----------------
		#-----------CHI
		#-----------------
          if(sd.prop.chi>0){
		proposed.log.chi=rnorm(1,current.log.chi,sd=sd.prop.chi)
		if(proposed.log.chi<(-10)) {
			proposed.log.chi=-20-proposed.log.chi
			}
		if(proposed.log.chi>10) {
			proposed.log.chi=20-proposed.log.chi
			}
		proposed.sim.area.chi=sim.area^exp(proposed.log.chi)
		proposed.p.extinct=exp(current.log.mu)/proposed.sim.area.chi
		proposed.p.extinct[proposed.p.extinct>1]=1
                proposed.p.extinct.stack=NULL
                for(i in 1:(nyear-1)) {
                  proposed.p.extinct.stack=c(proposed.p.extinct.stack,proposed.p.extinct[z.index.list[[i]]])
                }

        proposed.p.extinct.re.stack=proposed.p.extinct.stack*(1-current.p.colon.stack)
        proposed.prob.stack=z.data.1.nminus1.stack*(1-proposed.p.extinct.re.stack)+(1-z.data.1.nminus1.stack)*current.p.colon.stack
    	log.numerator.2.n=sum(z.data.2.n.stack*log(proposed.prob.stack)+(1-z.data.2.n.stack)*log(1-proposed.prob.stack))
		log.MH=log.numerator.2.n-log.denominator.2.n
		accept=decide(log.MH)
		if (accept) {
                  	current.log.chi=proposed.log.chi
			current.sim.area.chi=proposed.sim.area.chi
                        current.p.extinct.stack=proposed.p.extinct.stack
                        log.denominator.2.n=log.numerator.2.n
			}
              }
		#-------------------
		# GAMMA AND BETA
		#-------------------
                if(gamma.beta.bivnorm.low==TRUE){
                  temp=gamma.beta.bivnorm.no.missing(current.log.gamma=current.log.gamma,current.log.beta=current.log.beta,cov.mat=cov.prop.gamma.beta.low,z.index.list=z.index.list,sim.area=sim.area,proposed.area.occ.list=proposed.area.occ.list,proposed.s.i.sq.list=proposed.s.i.sq.list,z.data.list=z.data.list,current.sim.alpha.distance.list=current.sim.alpha.distance.list,current.p.extinct.stack=current.p.extinct.stack,z.data.1.nminus1.stack=z.data.1.nminus1.stack,one.stack=one.stack,zero.stack=zero.stack,z.data.2.n.stack=z.data.2.n.stack,log.denominator.2.n=log.denominator.2.n)
                  if(temp$accept==1){
                    current.log.gamma=temp$current.log.gamma
                    current.log.beta=temp$current.log.beta
                    current.area.occ.list=temp$current.area.occ.list
                    current.s.i.sq.list=temp$current.s.i.sq.list
                    current.p.colon.stack=temp$current.p.colon.stack
                    log.denominator.2.n=temp$log.denominator.2.n
                  }
                }
            
            if(gamma.beta.bivnorm.high==TRUE){
                  temp=gamma.beta.bivnorm.no.missing(current.log.gamma=current.log.gamma,current.log.beta=current.log.beta,cov.mat=cov.prop.gamma.beta.high,z.index.list=z.index.list,sim.area=sim.area,proposed.area.occ.list=proposed.area.occ.list,proposed.s.i.sq.list=proposed.s.i.sq.list,z.data.list=z.data.list,current.sim.alpha.distance.list=current.sim.alpha.distance.list,current.p.extinct.stack=current.p.extinct.stack,z.data.1.nminus1.stack=z.data.1.nminus1.stack,one.stack=one.stack,zero.stack=zero.stack,z.data.2.n.stack=z.data.2.n.stack,log.denominator.2.n=log.denominator.2.n)
                  if(temp$accept==1){
                    current.log.gamma=temp$current.log.gamma
                    current.log.beta=temp$current.log.beta
                    current.area.occ.list=temp$current.area.occ.list
                    current.s.i.sq.list=temp$current.s.i.sq.list
                    current.p.colon.stack=temp$current.p.colon.stack
                    log.denominator.2.n=temp$log.denominator.2.n
                  }
                }
            
                #-----------------
		#-----------GAMMA
		#-----------------
          if(sd.prop.gamma>0) {
		proposed.log.gamma=rnorm(1,current.log.gamma,sd=sd.prop.gamma)
		if(proposed.log.gamma<(-10)) {
			proposed.log.gamma=-20-proposed.log.gamma
			}
		if(proposed.log.gamma>10) {
			proposed.log.gamma=20-proposed.log.gamma
			}

                proposed.p.colon.stack=NULL
                for(i in 1:(nyear-1)) {
                  proposed.p.colon.stack=c(proposed.p.colon.stack,(current.s.i.sq.list[[i]]/(current.s.i.sq.list[[i]]+exp(2*proposed.log.gamma))))
                }

                proposed.p.extinct.re.stack=current.p.extinct.stack*(1-proposed.p.colon.stack)
                proposed.prob.stack=z.data.1.nminus1.stack*(1-proposed.p.extinct.re.stack)+(1-z.data.1.nminus1.stack)*proposed.p.colon.stack
                log.numerator.2.n=sum(z.data.2.n.stack*log(proposed.prob.stack)+(1-z.data.2.n.stack)*log(1-proposed.prob.stack))
		log.MH=log.numerator.2.n-log.denominator.2.n
		accept=decide(log.MH)
		if(accept) {
			current.log.gamma=proposed.log.gamma
                        current.p.colon.stack=proposed.p.colon.stack
                       	log.denominator.2.n=log.numerator.2.n
			}

                #SECOND UPDATE IN AN ITERATION:
                if(gamma.twice==TRUE) {
                proposed.log.gamma=rnorm(1,current.log.gamma,sd=sd.prop.gamma)
		if(proposed.log.gamma<(-10)) {
			proposed.log.gamma=-20-proposed.log.gamma
			}
		if(proposed.log.gamma>10) {
			proposed.log.gamma=20-proposed.log.gamma
			}

                proposed.p.colon.stack=NULL
                for(i in 1:(nyear-1)) {
                  proposed.p.colon.stack=c(proposed.p.colon.stack,(current.s.i.sq.list[[i]]/(current.s.i.sq.list[[i]]+exp(2*proposed.log.gamma))))
                }

                proposed.p.extinct.re.stack=current.p.extinct.stack*(1-proposed.p.colon.stack)
                proposed.prob.stack=z.data.1.nminus1.stack*(1-proposed.p.extinct.re.stack)+(1-z.data.1.nminus1.stack)*proposed.p.colon.stack
                log.numerator.2.n=sum(z.data.2.n.stack*log(proposed.prob.stack)+(1-z.data.2.n.stack)*log(1-proposed.prob.stack))
		log.MH=log.numerator.2.n-log.denominator.2.n
		accept=decide(log.MH)
		if(accept) {
			current.log.gamma=proposed.log.gamma
                        current.p.colon.stack=proposed.p.colon.stack
                       	log.denominator.2.n=log.numerator.2.n
			}
              }
              }
		#-----------------
		#-----------BETA
		#-----------------
          if(sd.prop.beta>0) {
		proposed.log.beta=rnorm(1,current.log.beta,sd=sd.prop.beta)
		if(proposed.log.beta<(-10)) {
			proposed.log.beta=-20-proposed.log.beta
			}
                #INFORMATIVE PRIOR.
		if(proposed.log.beta>0) {
			proposed.log.beta=-proposed.log.beta
			}
		proposed.area.j.beta=sim.area^exp(proposed.log.beta)
                proposed.p.colon.stack=NULL
                for(i in 1:(nyear-1)) {
                  proposed.area.occ.list[[i]]=z.data.list[[i]][,1]*proposed.area.j.beta[z.index.list[[i]]]
                  proposed.s.i.sq.list[[i]]=(current.sim.alpha.distance.list[[i]]%*%proposed.area.occ.list[[i]])^2 
                  proposed.p.colon.stack=c(proposed.p.colon.stack,(proposed.s.i.sq.list[[i]]/(proposed.s.i.sq.list[[i]]+exp(2*current.log.gamma))))
                }

                proposed.p.extinct.re.stack=current.p.extinct.stack*(1-proposed.p.colon.stack)
                proposed.prob.stack=z.data.1.nminus1.stack*(1-proposed.p.extinct.re.stack)+(1-z.data.1.nminus1.stack)*proposed.p.colon.stack
                log.numerator.2.n=sum(z.data.2.n.stack*log(proposed.prob.stack)+(1-z.data.2.n.stack)*log(1-proposed.prob.stack))
		log.MH=log.numerator.2.n-log.denominator.2.n
		accept=decide(log.MH)
		if(accept) {
			current.log.beta=proposed.log.beta
			current.area.occ.list=proposed.area.occ.list
                        current.s.i.sq.list=proposed.s.i.sq.list
                        current.p.colon.stack=proposed.p.colon.stack
			log.denominator.2.n=log.numerator.2.n
			}
                	proposed.log.beta=rnorm(1,current.log.beta,sd=sd.prop.beta)
		if(proposed.log.beta<(-10)) {
			proposed.log.beta=-20-proposed.log.beta
			}

                #SECOND UPDATE IN A SINGLE INTERATION:
                if(beta.twice==TRUE) {
		if(proposed.log.beta>0) {
			proposed.log.beta=-proposed.log.beta
			}
		proposed.area.j.beta=sim.area^exp(proposed.log.beta)
                proposed.p.colon.stack=NULL
                for(i in 1:(nyear-1)) {
                  proposed.area.occ.list[[i]]=z.data.list[[i]][,1]*proposed.area.j.beta[z.index.list[[i]]]
                  proposed.s.i.sq.list[[i]]=(current.sim.alpha.distance.list[[i]]%*%proposed.area.occ.list[[i]])^2 
                  proposed.p.colon.stack=c(proposed.p.colon.stack,(proposed.s.i.sq.list[[i]]/(proposed.s.i.sq.list[[i]]+exp(2*current.log.gamma))))
                }

                proposed.p.extinct.re.stack=current.p.extinct.stack*(1-proposed.p.colon.stack)
                proposed.prob.stack=z.data.1.nminus1.stack*(1-proposed.p.extinct.re.stack)+(1-z.data.1.nminus1.stack)*proposed.p.colon.stack
                log.numerator.2.n=sum(z.data.2.n.stack*log(proposed.prob.stack)+(1-z.data.2.n.stack)*log(1-proposed.prob.stack))
		log.MH=log.numerator.2.n-log.denominator.2.n
		accept=decide(log.MH)
		if(accept) {
			current.log.beta=proposed.log.beta
			current.area.occ.list=proposed.area.occ.list
                        current.s.i.sq.list=proposed.s.i.sq.list
                        current.p.colon.stack=proposed.p.colon.stack
			log.denominator.2.n=log.numerator.2.n
			}
              }
              }
		#-----------------
		#-----------ALPHA
		#-----------------
          if(sd.prop.alpha>0){
		proposed.log.alpha=rnorm(1,current.log.alpha,sd=sd.prop.alpha)
		if(proposed.log.alpha<(-10)) {
			proposed.log.alpha=-20-proposed.log.alpha
			}
		if(proposed.log.alpha>10) {
			proposed.log.alpha=20-proposed.log.alpha
			}
               	proposed.sim.alpha.distance=exp(-exp(proposed.log.alpha)*sim.distance)
		diag(proposed.sim.alpha.distance)=0
                proposed.p.colon.stack=NULL
                  for(i in 1:(nyear-1)) {
                    proposed.sim.alpha.distance.list[[i]]=proposed.sim.alpha.distance[z.index.list[[i]],z.index.list[[i]]]
                    proposed.s.i.sq.list[[i]]=(proposed.sim.alpha.distance.list[[i]]%*%current.area.occ.list[[i]])^2
                    proposed.p.colon.stack=c(proposed.p.colon.stack,(proposed.s.i.sq.list[[i]]/(proposed.s.i.sq.list[[i]]+exp(2*current.log.gamma))))
                  }
	
		proposed.p.extinct.re.stack=current.p.extinct.stack*(1-proposed.p.colon.stack)
		proposed.prob.stack=z.data.1.nminus1.stack*(1-proposed.p.extinct.re.stack)+(1-z.data.1.nminus1.stack)*proposed.p.colon.stack
		if(sum(proposed.prob.stack<=0)>0){
			print("Zeros in Prob")
			proposed.prob.stack[proposed.prob.stack<=0]=zero.stack[proposed.prob.stack<=0]
			}
		log.numerator.2.n=sum(z.data.2.n.stack*log(proposed.prob.stack)+(1-z.data.2.n.stack)*log(1-proposed.prob.stack))
		log.MH=log.numerator.2.n-log.denominator.2.n
		accept=decide(log.MH)
		if(accept) {
			current.log.alpha=proposed.log.alpha
			current.sim.alpha.distance.list=proposed.sim.alpha.distance.list
			current.s.i.sq.list=proposed.s.i.sq.list
			current.p.colon.stack=proposed.p.colon.stack
                        log.denominator.2.n=log.numerator.2.n
			}

                #SECOND UPDATE IN AN ITERATION:
                if (alpha.twice==TRUE) {
                proposed.log.alpha=rnorm(1,current.log.alpha,sd=sd.prop.alpha)
		if(proposed.log.alpha<(-10)) {
			proposed.log.alpha=-20-proposed.log.alpha
			}
		if(proposed.log.alpha>10) {
			proposed.log.alpha=20-proposed.log.alpha
			}
               	proposed.sim.alpha.distance=exp(-exp(proposed.log.alpha)*sim.distance)
		diag(proposed.sim.alpha.distance)=0
                proposed.p.colon.stack=NULL
                  for(i in 1:(nyear-1)) {
                    proposed.sim.alpha.distance.list[[i]]=proposed.sim.alpha.distance[z.index.list[[i]],z.index.list[[i]]]
                    proposed.s.i.sq.list[[i]]=(proposed.sim.alpha.distance.list[[i]]%*%current.area.occ.list[[i]])^2
                    proposed.p.colon.stack=c(proposed.p.colon.stack,(proposed.s.i.sq.list[[i]]/(proposed.s.i.sq.list[[i]]+exp(2*current.log.gamma))))
                  }
	
		proposed.p.extinct.re.stack=current.p.extinct.stack*(1-proposed.p.colon.stack)
		proposed.prob.stack=z.data.1.nminus1.stack*(1-proposed.p.extinct.re.stack)+(1-z.data.1.nminus1.stack)*proposed.p.colon.stack
		if(sum(proposed.prob.stack<=0)>0){
			print("Zeros in Prob")
			proposed.prob.stack[proposed.prob.stack<=0]=zero.stack[proposed.prob.stack<=0]
			}
		log.numerator.2.n=sum(z.data.2.n.stack*log(proposed.prob.stack)+(1-z.data.2.n.stack)*log(1-proposed.prob.stack))
		log.MH=log.numerator.2.n-log.denominator.2.n
		accept=decide(log.MH)
                
		if(accept) {
			current.log.alpha=proposed.log.alpha
			current.sim.alpha.distance.list=proposed.sim.alpha.distance.list
			current.s.i.sq.list=proposed.s.i.sq.list
			current.p.colon.stack=proposed.p.colon.stack
                        log.denominator.2.n=log.numerator.2.n
			}
               }
                      }
                
		if(n==iter.chain[n]) {
			log.mu.chain=c(log.mu.chain,current.log.mu)
			log.chi.chain=c(log.chi.chain,current.log.chi)
			log.gamma.chain=c(log.gamma.chain,current.log.gamma)
			log.beta.chain=c(log.beta.chain,current.log.beta)
			log.alpha.chain=c(log.alpha.chain,current.log.alpha)    
			}
                if(n==iter.print[n]) {
                  print(n)
                }  
              }
		return(list(log.mu.chain=log.mu.chain,log.chi.chain=log.chi.chain,log.gamma.chain=log.gamma.chain,
		log.beta.chain=log.beta.chain,log.alpha.chain=log.alpha.chain))
}
