#FUNCTIONS USED IN DIAGNOSING CONVERGENCE AND IN FORMATTING DATASETS TO CODA OBJECTS

#(NOTE: THE "COMBINE CHAIN" FUNCTIONS ARE USED TO STRING TOGETHER THE CHAINS RUN ON THE UNIX BOXES. I GENERALLY FORM 2 CHAINS FROM 20 CHAINS--RATHER THAN RUNNING 2 CHAINS FOR A LONG TIME-- TO SAVE ON COMPUTATION TIME.)

accept.calculate<-function(option=3,x,nthin=1,niter=length(x$log.mu.chain)) {
  attach(x)
  if(option==1){
  par.list=list(log.mu.chain=log.mu.chain,log.chi.chain=log.chi.chain,log.gamma.chain=log.gamma.chain,
  log.beta.chain=log.beta.chain,log.alpha.chain=log.alpha.chain)
}
if(option==2){
  par.list=list(muz.missing.chain=muz.missing.chain,mupsi1.chain=mupsi1.chain,log.mu.chain=log.mu.chain,log.chi.chain=log.chi.chain,
  log.gamma.chain=log.gamma.chain,log.beta.chain=log.beta.chain,log.alpha.chain=log.alpha.chain)
}
if(option==3){
  par.list=list(muz.chain=muz.chain,muz.missing.chain=muz.missing.chain,p.chain=p.chain,mupsi1.chain=mupsi1.chain,log.mu.chain=log.mu.chain,
  log.chi.chain=log.chi.chain, log.gamma.chain=log.gamma.chain, log.beta.chain=log.beta.chain, log.alpha.chain=log.alpha.chain)
}
  temp.env=new.env()
 
  for (i in 1:length(par.list)) {
    if(length(par.list[[i]])==niter/nthin){
      x=acceptance.rate(par.list[[i]])
      assign(paste("acc.",names(par.list)[i],sep=""),x,envir=temp.env)
    }
    else{
    x=apply(par.list[[i]],1,acceptance.rate)
    assign(paste("acc.",names(par.list)[i],sep=""),x,envir=temp.env)
  }
  }
  acclist=as.list(temp.env)
  detach(x)
  return(acclist)
}

#---------------------------------------------
plot.muz<-function(x1,x2,acclist1,niter=length(x1$log.much.chain),plot.thin=1,nthin=1) {
  nyear=nrow(x1$muz.chain)
  index.y=seq(1,ncol(x1$muz.chain),by=plot.thin)
  plot.x=seq(1,niter,by=nthin)[index.y]
  attach(acclist1)
  if(nyear>5) par(mfrow=c(4,2))
  else par(mfrow=c(3,2))
plot(plot.x,x1$muz.chain[1,index.y],type="l",xlab="n iter",ylab="muz.1",col="red",sub=paste("Acceptance Rate=",acc.muz.chain[1]))
  lines(plot.x,x2$muz.chain[1,index.y],col="blue")
plot(plot.x,x1$muz.chain[2,index.y],type="l",xlab="n iter",ylab="muz.2",col="red",sub=paste("Acceptance Rate=",acc.muz.chain[2]))
    lines(plot.x,x2$muz.chain[2,index.y],col="blue")
plot(plot.x,x1$muz.chain[3,index.y],type="l",xlab="n iter",ylab="muz.3",col="red",sub=paste("Acceptance Rate=",acc.muz.chain[3]))
    lines(plot.x,x2$muz.chain[3,index.y],col="blue")
plot(plot.x,x1$muz.chain[4,index.y],type="l",xlab="n iter",ylab="muz.4",col="red",sub=paste("Acceptance Rate=",acc.muz.chain[4]))
  lines(plot.x,x2$muz.chain[4,index.y],col="blue")
plot(plot.x,x1$muz.chain[5,index.y],type="l",xlab="n iter",ylab="muz.5",col="red",sub=paste("Acceptance Rate=",acc.muz.chain[5]))
  lines(plot.x,x2$muz.chain[5,index.y],col="blue")
  if(nyear>5){
plot(plot.x,x1$muz.chain[6,index.y],type="l",xlab="n iter",ylab="muz.6",col="red",sub=paste("Acceptance Rate=",acc.muz.chain[6]))
  lines(plot.x,x2$muz.chain[6,index.y],col="blue")
plot(plot.x,x1$muz.chain[7,index.y],type="l",xlab="n iter",ylab="muz.n",col="red",sub=paste("Acceptance Rate=",acc.muz.chain[7]))
  lines(plot.x,x2$muz.chain[7,index.y],col="blue")
}
detach(acclist1)
}

plot.missing<-function(x1,x2,acclist1,niter=length(x1$log.mu.chain),plot.thin=1,nthin=1) {
  nyear=nrow(x1$muz.chain)
  index.y=seq(1,ncol(x1$muz.chain),by=plot.thin)
  plot.x=seq(1,niter,by=nthin)[index.y]
  attach(acclist1)
  if(nyear>5) par(mfrow=c(4,2))
  else par(mfrow=c(3,2))

plot(plot.x,x1$muz.missing.chain[1,index.y],type="l",xlab="n iter",ylab="muz.missing.1",col="red",sub=paste("Acceptance Rate=",acc.muz.missing.chain[1]))
 lines(plot.x,x2$muz.missing.chain[1,index.y],col="blue")
plot(plot.x,x1$muz.missing.chain[2,index.y],type="l",xlab="n iter",ylab="muz.missing.3",col="red",sub=paste("Acceptance Rate=",acc.muz.missing.chain[2]))
 lines(plot.x,x2$muz.missing.chain[2,index.y],col="blue")
plot(plot.x,x1$muz.missing.chain[3,index.y],type="l",xlab="n iter",ylab="muz.missing.3",col="red",sub=paste("Acceptance Rate=",acc.muz.missing.chain[3]))
 lines(plot.x,x2$muz.missing.chain[3,index.y],col="blue")
  plot(plot.x,x1$muz.missing.chain[4,index.y],type="l",xlab="n iter",ylab="muz.missing.4",col="red",sub=paste("Acceptance Rate=",acc.muz.missing.chain[4]))
 lines(plot.x,x2$muz.missing.chain[4,index.y],col="blue")
plot(plot.x,x1$muz.missing.chain[5,index.y],type="l",xlab="n iter",ylab="muz.missing.5",col="red",sub=paste("Acceptance Rate=",acc.muz.missing.chain[5]))
 lines(plot.x,x2$muz.missing.chain[5,index.y],col="blue")
  if(nyear>5) {
plot(plot.x,x1$muz.missing.chain[6,index.y],type="l",xlab="n iter",ylab="muz.missing.6",col="red",sub=paste("Acceptance Rate=",acc.muz.missing.chain[6]))
lines(plot.x,x2$muz.missing.chain[6,index.y],col="blue")
plot(plot.x,x1$muz.missing.chain[7,index.y],type="l",xlab="n iter",ylab="muz.missing.n",col="red",sub=paste("Acceptance Rate=",acc.muz.missing.chain[7]))
lines(plot.x,x2$muz.missing.chain[7,index.y],col="blue")
}
detach(acclist1)
}

plot.p<-function(x1,x2,acclist1,niter=length(x1$log.mu.chain),nthin=1,plot.thin=1) {
  attach(acclist1)
  attach(x1)
  index.y=seq(1,ncol(p.chain),by=plot.thin)
  plot.x=seq(1,niter,by=nthin)[index.y]
  if(nrow(p.chain)>5) par(mfrow=c(4,2))
  else par(mfrow=c(3,2))
plot(plot.x,p.chain[1,index.y],type="l",xlab="n iter",ylab="p.1",col="red",sub=paste("Acceptance Rate=",acc.p.chain[1]))
  lines(plot.x,x2$p.chain[1,index.y],col="blue")
plot(plot.x,p.chain[2,index.y],type="l",xlab="n iter",ylab="p.2",col="red",sub=paste("Acceptance Rate=",acc.p.chain[2]))
  lines(plot.x,x2$p.chain[2,index.y],col="blue")
  plot(plot.x,p.chain[3,index.y],type="l",xlab="n iter",ylab="p.3",col="red",sub=paste("Acceptance Rate=",acc.p.chain[3]))
  lines(plot.x,x2$p.chain[3,index.y],col="blue")
  plot(plot.x,p.chain[4,index.y],type="l",xlab="n iter",ylab="p.4",col="red",sub=paste("Acceptance Rate=",acc.p.chain[4]))
  lines(plot.x,x2$p.chain[4,index.y],col="blue")
  plot(plot.x,p.chain[5,index.y],type="l",xlab="n iter",ylab="p.5",col="red",sub=paste("Acceptance Rate=",acc.p.chain[5]))
    lines(plot.x,x2$p.chain[5,index.y],col="blue")
  if(nrow(p.chain)>5){
plot(plot.x,p.chain[6,index.y],type="l",xlab="n iter",ylab="p.6",col="red",sub=paste("Acceptance Rate=",acc.p.chain[6]))
  lines(plot.x,x2$p.chain[6,index.y],col="blue")
plot(plot.x,p.chain[7,index.y],type="l",xlab="n iter",ylab="p.n",col="red",sub=paste("Acceptance Rate=",acc.p.chain[7]))
  lines(plot.x,x2$p.chain[7,index.y],col="blue")
}
  detach(acclist1)
  detach(x1)
}

plot.ifm.pars <- function(x1,x2,acclist1,niter=length(x1$log.mu.chain),nthin=1,plot.thin=1,mupsi1=TRUE){
  par(mfrow=c(3,2))
  attach(acclist1)
  attach(x1)
  index.y=seq(1,length(log.alpha.chain),by=plot.thin)
  plot.x=seq(1,niter,by=nthin)[index.y]
  if(mupsi1) {
  plot(plot.x,mupsi1.chain[index.y],type="l",xlab="n iter",ylab="mupsi1",col="red",
       sub=paste("Acceptance Rate=",acc.mupsi1.chain))
  lines(plot.x,x2$mupsi1.chain[index.y],col="blue")
}
  plot(plot.x,log.mu.chain[index.y],type="l",xlab="n iter",ylab="log.mu",col="red",
       sub=paste("Acceptance Rate=",acc.log.mu.chain))
  lines(plot.x,x2$log.mu.chain[index.y],col="blue")
  plot(plot.x,log.chi.chain[index.y],type="l",xlab="n iter",ylab="log.chi",col="red",
       sub=paste("Acceptance Rate=",acc.log.chi.chain))
  lines(plot.x,x2$log.chi.chain[index.y],col="blue")
  plot(plot.x,log.gamma.chain[index.y],type="l",xlab="n iter",ylab="log.gamma",col="red",
       sub=paste("Acceptance Rate=",acc.log.gamma.chain))
  lines(plot.x,x2$log.gamma.chain[index.y],col="blue")
  plot(plot.x,log.beta.chain[index.y],type="l",xlab="n iter",ylab="log.beta",col="red",
       sub=paste("Acceptance Rate=",acc.log.beta.chain))
  lines(plot.x,x2$log.beta.chain[index.y],col="blue")
  plot(plot.x,log.alpha.chain[index.y],type="l",xlab="n iter",ylab="log.alpha",col="red",
       sub=paste("Acceptance Rate=",acc.log.alpha.chain))
  lines(plot.x,x2$log.alpha.chain[index.y],col="blue")
  detach(acclist1)
  detach(x1)
}

plot.ifm.pars.points <- function(x1,x2,niter=length(x1$log.mu.chain),nthin=1,plot.thin=1,mupsi1=TRUE){
  par(mfrow=c(3,2))
  attach(x1)
  index.y=seq(1,length(log.alpha.chain),by=plot.thin)
  plot.x=seq(1,niter,by=nthin)[index.y]
  if(mupsi1) {
  plot(plot.x,mupsi1.chain[index.y],pch=".",xlab="n iter",ylab="mupsi1",col="red")
  points(plot.x,x2$mupsi1.chain[index.y],pch=".",col="blue")
}
  plot(plot.x,log.mu.chain[index.y],pch=".",xlab="n iter",ylab="log.mu",col="red")
  points(plot.x,x2$log.mu.chain[index.y],pch=".",col="blue")
  plot(plot.x,log.chi.chain[index.y],pch=".",xlab="n iter",ylab="log.chi",col="red")
  points(plot.x,x2$log.chi.chain[index.y],pch=".",col="blue")
  plot(plot.x,log.gamma.chain[index.y],pch=".",xlab="n iter",ylab="log.gamma",col="red")
  points(plot.x,x2$log.gamma.chain[index.y],pch=".",col="blue")
  plot(plot.x,log.beta.chain[index.y],pch=".",xlab="n iter",ylab="log.beta",col="red")
  points(plot.x,x2$log.beta.chain[index.y],pch=".",col="blue")
  plot(plot.x,log.alpha.chain[index.y],pch=".",xlab="n iter",ylab="log.alpha",col="red")
  points(plot.x,x2$log.alpha.chain[index.y],pch=".",col="blue")
  detach(x1)
}

#-----------------------------------------------------
combine.chains<-function(x1,x2,nburnin,nthin=1,z.thin=TRUE) {
  x=x1
  chain.length=length(x$log.alpha.chain)
  nburnin.thin=round(nburnin/nthin)+1
for(i in 1:length(x)){
  if(is.vector(x[[i]])) x[[i]]=c(x[[i]][nburnin.thin:chain.length],x2[[i]][nburnin.thin:chain.length])
  if(is.matrix(x[[i]]))  x[[i]]=cbind(x[[i]][,nburnin.thin:chain.length],x2[[i]][,nburnin.thin:chain.length])
   if(is.array(x[[i]]) & !is.matrix(x[[i]])) {
     if(z.thin==TRUE) x[[i]]=c(x[[i]][,,seq(nburnin.thin,dim(x1[[i]])[3],by=5)],x2[[i]][,,seq(nburnin.thin,dim(x1[[i]])[3],by=5)])
     else x[[i]]=c(x[[i]][,,nburnin.thin:dim(x1[[i]])[3]],x2[[i]][,,nburnin.thin:dim(x1[[i]])[3]])
   }
}
  if (length(x)>5) dim(x$z.chain)=c(nsite,nyear,length(x$z.chain)/(nsite*nyear))
  x
}


#-----------------------------------------------------
#THIS FUNCTION IS USED TO COMBINE MORE THAN 2 RUNS. THE BURNIN PERIOD FOR THE
#FIRST CHAIN SHOULD BE 0 WHEN COMBINED WITH RUNS>2, I.E., THE BURNIN PERIOD SHOULD
#BE REMOVED ONLY ONE TIME FOR EACH CHAIN.
#NOTE: THINNING ON Z IS ONLY DONE ON FIRST CHAIN.
combine.chains.unequal<-function(x1,x2,nburnin2,nthin=1,z.thin=TRUE) {
  x=x1
  chain.length1=length(x$log.alpha.chain)
  chain.length2=length(x2$log.alpha.chain)
  nburnin.thin2=round(nburnin2/nthin)+1
for(i in 1:length(x)){
  if(is.vector(x[[i]])) x[[i]]=c(x[[i]][1:chain.length1],x2[[i]][nburnin.thin2:chain.length2])
  if(is.matrix(x[[i]]))  x[[i]]=cbind(x[[i]][,1:chain.length1],x2[[i]][,nburnin.thin2:chain.length2])
  if(is.array(x[[i]]) & !is.matrix(x[[i]])) {
if(z.thin==TRUE) {
x[[i]]=c(x[[i]],x2[[i]][,,seq(nburnin.thin2,chain.length2,by=5)])
}
else x[[i]]=c(x[[i]],x2[[i]][,,nburnin.thin2:dim(x2[[i]])[3]])
}
}
  if (length(x)>5) dim(x$z.chain)=c(nsite,nyear,length(x$z.chain)/(nsite*nyear))
  x
}

#-------------------------------------------------------------
summary.chain<-function(chain,name="",option=2) {
  if (name=="") name=substitute(chain)
   q.025=round(quantile(chain,0.025),3)
   q.50=round(quantile(chain,0.5),3)
   q.975=round(quantile(chain,0.975),3)
if(option==1){
   plot(density(chain),main=name,sub=paste(q.50," (",q.025," - ",q.975,")",sep=""))
 }
   if(option==2 | option==3){
   plot(density(chain),main=name,sub=paste(q.50," (",q.025," - ",q.975,"); BT ",round(exp(q.50),3)," (",round(exp(q.025),3)," - ",round(exp(q.975),3),")",sep=""))
 }
    print(name)
   if(option==1 | option==3) {
	print(summary(chain))
        temp=hist(chain,breaks=20,plot=FALSE)
        mode=temp$mids[temp$density==max(temp$density)]
        print(paste("q.025=",q.025))
        print(paste("q.975=",q.975))
        print(paste("MODE=",mode))
      }
        if (option==2 | option==3) {
	print(exp(summary(chain)))
        print(paste("q.025=",round(exp(q.025),3)))
        print(paste("q.975=",round(exp(q.975),3)))
        temp=hist(chain,breaks=20,plot=FALSE)
        mode=temp$mids[temp$density==max(temp$density)]
        print(paste("MODE=",round(exp(mode),4)))
      }
	}

coda.create <- function(object,file.name,write.index=TRUE,par.list=list("mupsi1.chain","log.mu.chain","log.chi.chain","log.beta.chain","log.delta.chain","log.alpha.chain"),niter=101000,nthin=10) {
  iter.num.short=seq(1,niter,by=nthin)
  iter.num=rep(iter.num.short,length(par.list))
  value=NULL
  par.num=length(par.list)
  for(i in 1:length(par.list)){
    value=c(value,object[[names(object)[names(object)==par.list[i]]]])
  }
  temp=data.frame(iter.num,value)
  write.table(temp,paste(file.name,".txt",sep=""),col.names=FALSE,row.names=FALSE,sep="\t")
  if(write.index==TRUE) {
      row.num=seq(1,length(iter.num),by=length(iter.num.short))
      row.num2=c((row.num[2:length(row.num)]-1),length(iter.num))
      write.table(data.frame(as.character(par.list),row.num,row.num2),file=paste(file.name,"_Index",".txt",sep=""),col.names=FALSE,row.names=FALSE,sep="\t")         }
}

p.chain.list<-function(object) {
  t.nyear=nrow(object)
  p.list=new.env()
  for(i in t.nyear:1) {
    temp1=object[i,]
    assign(paste("p.",i,sep=""),temp1,p.list)
  }
    p.list=as.list(p.list)
    }

p.list.insert <- function(mcmc.list){
  temp=p.chain.list(mcmc.list[[c("p.chain")]])
  insert.list=new.env()
  for(i in 1:length(mcmc.list)) assign(names(mcmc.list)[i],mcmc.list[[i]],insert.list)
    
  for(i in 1:length(temp))  assign(names(temp)[i],temp[[i]],insert.list)
 
  as.list(insert.list)
}

delta.rename <- function(object) {
  names(object)[names(object)=="log.gamma.chain"]="log.delta.chain"
  return(object)
}

  
