#------------------
# EXAMINATION OF THE IFM MISSING
#------------------
load("SIMULATE_DATA_100_20_10.RData")
#NOTE: YOU WILL NEED TO RENAME SUPPLEMENTARY FILES IN ORDER TO LOAD FUNCTIONS.
source("1_MCMC_FUNCTIONS.R")
source("3_IFM_MISSING_MCMC_FUNCTION.R")
source("5_CHAIN_DIAGNOSTICS_FUNCTIONS.R")
library("coda")

#THESE PARAMETERS WILL NEED TO BE EDITED TO CORRESPOND TO THE SIMULATED DATA:
niter=25000
nsite=100
nyear=20
nthin=25
nrep=25
seed=101
nmissing=sum(is.na(z.sim.no.missing.values))

#sim.init1=list(z.missing=0,mupsi1=0.29,log.alpha=runif(1,-2,0.5), log.beta=runif(1,-2,0.5),log.gamma=runif(1,-2,0.5),log.mu=runif(1,-2,0.5),log.chi=runif(1,-2,0.5))

#sim.im1=ifm.missing.MCMC(niter=niter,init=sim.init1, z.data=z.sim.no.missing.values, sim.distance=sim.distance,sim.area=sim.area, sd.prop.alpha=0.15,sd.prop.beta=0.75,sd.prop.gamma=0.2,sd.prop.mu=0.3,sd.prop.chi=0.5,gamma.beta.bivnorm.high=FALSE,gamma.beta.bivnorm.low=FALSE,nsite.subset=10,nthin=nthin,print.by=100)

sim.init1=list(z.missing=0,mupsi1=0.29,log.alpha=log(0.2), log.beta=log(0.5),log.gamma=log(10),log.mu=log(0.25),log.chi=log(0.25))
sim.im1=ifm.missing.MCMC(niter=niter,init=sim.init1, z.data=z.sim.no.missing.values, sim.distance=sim.distance,sim.area=sim.area,sd.prop.mupsi1=0, sd.prop.alpha=0,sd.prop.beta=0.75,sd.prop.gamma=0,sd.prop.mu=0,sd.prop.chi=0,gamma.beta.bivnorm.high=FALSE,gamma.beta.bivnorm.low=FALSE,nsite.subset=10,nthin=nthin,print.by=100,seed=1)

(accept.calculate(option=2,x=sim.im1))

sim.init2=list(z.missing=0,mupsi1=runif(1),log.alpha=runif(1,-2,0.5), log.beta=runif(1,-2,0.5),log.gamma=runif(1,-2,0.5),log.mu=runif(1,-2,0.5),log.chi=runif(1,-2,0.5))

sim.im2=ifm.missing.MCMC(niter=niter,init=sim.init2, z.data=z.sim.no.missing.values, sim.distance=sim.distance,sim.area=sim.area, sd.prop.alpha=0.15,sd.prop.beta=0.75,sd.prop.gamma=0.2,sd.prop.mu=0.3,sd.prop.chi=0.5,gamma.beta.bivnorm.high=FALSE,gamma.beta.bivnorm.low=FALSE,nsite.subset=10,nthin=nthin,print.by=100)

coda.create(sim.im1,"sim_im1",niter=niter,nthin=nthin)
coda.create(sim.im2,"sim_im2",niter=niter,nthin=nthin)
sim.im=combine.chains(sim.im1,sim.im2,nburnin=1000,nthin=25)
  
sim.temp1=read.coda("sim_im1.txt","sim_im1_Index.txt")
sim.temp2=read.coda("sim_im2.txt","sim_im2_Index.txt")
sim.temp.list=mcmc.list(sim.temp1,sim.temp2)

coda.create(sim.im,"sim_im",niter=4.8e4,nthin=25)
sim.temp.long=read.coda("sim_im.txt","sim_im_Index.txt")


#TRUE PARAMETER ESTIMATES:
mean(z.sim.no.missing.values[,1])
# MU: 0.25, -1.39
# CHI: 0.25, -1.39
# BETA: 0.5, -0.7
# GAMMA: 10, 2.3
# ALPHA: 0.2, -1.6
summary(sim.temp.list)
summary(sim.temp.long)

pdf(file="SIM_IM_100_20.pdf")
plot(sim.temp.list)
plot(sim.temp.long)
dev.off()
save(sim.temp.list,file="SIM_IFM_MISSING_100_20.RData")
